#line 1 "C:/Users/DEON4/Desktop/firmware sim800l/FIRMWARE_DEON-UTR-PDS-V1_BASE_U1/FIRMWARE_DEON-UTR-PDS-V1_BASE_U1_v1.0.2.c/FIRMWARE_DEON_UTR_PDS_V1_BASE_U1.c"
#line 1 "c:/users/deon4/desktop/firmware sim800l/firmware_deon-utr-pds-v1_base_u1/firmware_deon-utr-pds-v1_base_u1_v1.0.2.c/built_in.h"
#line 102 "C:/Users/DEON4/Desktop/firmware sim800l/FIRMWARE_DEON-UTR-PDS-V1_BASE_U1/FIRMWARE_DEON-UTR-PDS-V1_BASE_U1_v1.0.2.c/FIRMWARE_DEON_UTR_PDS_V1_BASE_U1.c"
sbit MFRC522_CS at LATC.B3;
sbit MFRC522_Rst at LATA.B0;
sbit SoftSPI_SDO at LATC.B1;
sbit SoftSPI_CLK at LATC.B2;
sbit SoftSPI_SDI at LATC.B0;
sbit MFRC522_CS_Direction at TRISC1_Bit;
sbit MFRC522_Rst_Direction at TRISA0_Bit;
sbit SoftSPI_SDO_Direction at TRISC1_Bit;
sbit SoftSPI_CLK_Direction at TRISC2_Bit;
sbit SoftSPI_SDI_Direction at TRISC0_Bit;

int cuenta = 0;
char key[6] = { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };
char writeData[] = "Una cadena";

void InitMCU();
void Init_Interrupt();
unsigned char MFRC_getVersion(void);
static void MFRC522_Wr( char addr, char value );
static char MFRC522_Rd( char addr );
static void MFRC522_Clear_Bit( char addr, char mask );
static void MFRC522_Set_Bit( char addr, char mask );
void MFRC522_Reset();
void MFRC522_AntennaOn();
void MFRC522_AntennaOff();
void MFRC522_Init();
char MFRC522_ToCard( char command, char *sendData, char sendLen, char *backData, unsigned *backLen );
char MFRC522_Request( char reqMode, char *TagType );
void MFRC522_CRC( char *dataIn, char length, char *dataOut );
char MFRC522_SelectTag( char *serNum );
void MFRC522_Halt();
char MFRC522_Auth( char authMode, char BlockAddr, char *Sectorkey, char *serNum );
char MFRC522_Write( char blockAddr, char *writeData );
char MFRC522_Read( char blockAddr, char *recvData );
char MFRC522_AntiColl( char *serNum );
char MFRC522_isCard( char *TagType ) ;
char MFRC522_ReadCardSerial( char *str );

void interrupt()
{

 if (PIR0.TMR0IF){
 TMR0L = 0x05;
 TMR0H = 0xFF;

 cuenta++;
 if (cuenta >= 500) {
  LATD.F0  = ~ LATD.F0 ;
 cuenta = 0;
 }

 PIR0.TMR0IF = 0;
 }
}

void main()
{
 char msg[12];
 char UID[6];
 unsigned int TagType;
 char size;
 char status1;
 char i;

 InitMCU();
 Init_Interrupt();

 while (1) {

 MFRC522_CS = 0;
 status1 = MFRC_getVersion();
 Uart1_Escribir_Texto("Status del request: ");
 UART1_Write(status);
 UART1_Write(0x0D);
 Uart1_Escribir_Texto("Despues del request");
 UART1_Write(0x0D);
 Uart1_Escribir_Texto("=============================");
 UART1_Write(0x0D);
 MFRC522_CS = 1;
 delay_ms(50);
#line 223 "C:/Users/DEON4/Desktop/firmware sim800l/FIRMWARE_DEON-UTR-PDS-V1_BASE_U1/FIRMWARE_DEON-UTR-PDS-V1_BASE_U1_v1.0.2.c/FIRMWARE_DEON_UTR_PDS_V1_BASE_U1.c"
 }
}

void InitMCU()
{
 ANSELA = 0x00;
 ANSELC = 0x00;
 ANSELD = 0x00;
 ANSELE = 0x00;

 TRISA = 0x00;
 TRISC = 0x00;
 TRISD = 0x00;
 TRISE = 0x00;

 TRISC.B1 = 1;

 LATA = 0x00;
 LATC = 0x00;
 LATD = 0x00;
 LATE = 0x00;

 RX1PPS = 0x0C;
 RB5PPS = 0x09;





 UART1_Init(115200);
 delay_ms(100);

 MFRC522_CS = 1;
 MFRC522_CS_Direction = 0;
 Soft_SPI_Init();

 MFRC522_Init();
}

void Init_Interrupt()
{
 INTCON = 0xC0;


 T0CON0 = 0x90;
 T0CON1 = 0x46;
 PIE0 = 0x20;
 TMR0L = 0x05;
 TMR0H = 0xFF;
}

static void MFRC522_Wr( char addr, char value )
{
 MFRC522_CS = 0;
 Soft_SPI_Write( ( addr << 1 ) & 0x7E );
 Soft_SPI_Write( value );
 MFRC522_CS = 1;
}

static char MFRC522_Rd( char addr )
{
 char value;
 MFRC522_CS = 0;
 Soft_SPI_Write( (( addr << 1 ) & 0x7E) | 0x80 );
 value = Soft_SPI_Read( 0x00 );
 MFRC522_CS = 1;
 return value;
}

static void MFRC522_Clear_Bit( char addr, char mask )
{
 MFRC522_Wr( addr, MFRC522_Rd( addr ) & (~mask) );
}

static void MFRC522_Set_Bit( char addr, char mask )
{
 MFRC522_Wr( addr, MFRC522_Rd( addr ) | mask );
}

void MFRC522_Reset()
{
 MFRC522_Wr(  0x01 ,  0x0F  );
}

void MFRC522_AntennaOn()
{
 MFRC522_Set_Bit(  0x14 , 0x03 );
}

void MFRC522_AntennaOff()
{
 MFRC522_Clear_Bit(  0x14 , 0x03 );
}

void MFRC522_Init()
{
 MFRC522_CS_Direction = 0;
 MFRC522_Rst_Direction = 0;
 MFRC522_CS = 1;
 MFRC522_Rst = 1;

 MFRC522_Reset();

 MFRC522_Wr(  0x2A , 0x8D );
 MFRC522_Wr(  0x2B , 0x3E );
 MFRC522_Wr(  0x2D , 30 );
 MFRC522_Wr(  0x2C , 0 );

 MFRC522_Wr(  0x15 , 0x40 );
 MFRC522_Wr(  0x11 , 0x3D );




 MFRC522_AntennaOn();
}

char MFRC522_ToCard( char command, char *sendData, char sendLen, char *backData, unsigned *backLen )
{
 char _status =  2 ;
 char irqEn = 0x00;
 char waitIRq = 0x00;
 char lastBits;
 char n;
 unsigned i;

 switch (command) {
 case  0x0E :
 irqEn = 0x12;
 waitIRq = 0x10;
 break;
 case  0x0C :
 irqEn = 0x77;
 waitIRq = 0x30;
 break;
 default:
 break;
 }
 MFRC522_Wr(  0x02 , irqEn | 0x80 );
 MFRC522_Clear_Bit(  0x04 , 0x80 );
 MFRC522_Set_Bit(  0x0A , 0x80 );
 MFRC522_Wr(  0x01 ,  0x00  );


 for ( i=0; i < sendLen; i++ ) {
 MFRC522_Wr(  0x09 , sendData[i] );
 }

 MFRC522_Wr(  0x01 , command );
 if (command ==  0x0C  ) {
 MFRC522_Set_Bit(  0x0D , 0x80 );
 }


 i = 0xFFFF;
 do {


 n = MFRC522_Rd(  0x04  );
 i--;
 } while ( i && !(n & 0x01) && !( n & waitIRq ) );
 MFRC522_Clear_Bit(  0x0D , 0x80 );
 if (i != 0) {
 if( !( MFRC522_Rd(  0x06  ) & 0x1B ) ) {
 _status =  0 ;
 if ( n & irqEn & 0x01 ) {
 _status =  1 ;
 }
 if ( command ==  0x0C  ) {
 n = MFRC522_Rd(  0x0A  );
 lastBits = MFRC522_Rd(  0x0C  ) & 0x07;
 if (lastBits) {
 *backLen = (n-1) * 8 + lastBits;
 } else {
 *backLen = n * 8;
 }
 if (n == 0) {
 n = 1;
 }
 if (n > 16) {
 n = 16;
 }

 for (i=0; i < n; i++) {
 backData[i] = MFRC522_Rd(  0x09  );
 }
 backData[i] = 0;
 }
 } else {
 _status =  2 ;
 }
 }


 return _status;
}

char MFRC522_Request( char reqMode, char *TagType )
{
 char _status;
 unsigned backBits;
 MFRC522_Wr(  0x0D , 0x07 );
 TagType[0] = reqMode;
 _status = MFRC522_ToCard(  0x0C , TagType, 1, TagType, &backBits );
 if ( (_status !=  0 ) || (backBits != 0x10) ) {
 _status =  2 ;
 }
 return _status;
}

void MFRC522_CRC( char *dataIn, char length, char *dataOut )
{
 char i, n;
 MFRC522_Clear_Bit(  0x05 , 0x04 );
 MFRC522_Set_Bit(  0x0A , 0x80 );


 for ( i = 0; i < length; i++ ) {
 MFRC522_Wr(  0x09 , *dataIn++ );
 }

 MFRC522_Wr(  0x01 ,  0x03  );

 i = 0xFF;

 do {
 n = MFRC522_Rd(  0x05  );
 i--;
 } while( i && !(n & 0x04) );

 dataOut[0] = MFRC522_Rd(  0x22  );
 dataOut[1] = MFRC522_Rd(  0x21  );
}

char MFRC522_SelectTag( char *serNum )
{
 char i;
 char _status;
 char size;
 unsigned recvBits;
 char buffer[9];



 buffer[0] =  0x93 ;
 buffer[1] = 0x70;

 for ( i=2; i < 7; i++ ) {
 buffer[i] = *serNum++;
 }

 MFRC522_CRC( buffer, 7, &buffer[7] );

 _status = MFRC522_ToCard(  0x0C , buffer, 9, buffer, &recvBits );
 if ( (_status ==  0 ) && (recvBits == 0x18) ) {
 size = buffer[0];
 } else {
 size = 0;
 }
 return size;
}


void MFRC522_Halt()
{
 unsigned unLen;
 char buff[4];

 buff[0] =  0x50 ;
 buff[1] = 0;
 MFRC522_CRC( buff, 2, &buff[2] );
 MFRC522_Clear_Bit(  0x08 , 0x80 );
 MFRC522_ToCard(  0x0C , buff, 4, buff, &unLen );
 MFRC522_Clear_Bit(  0x08 , 0x08 );
}

char MFRC522_Auth( char authMode, char BlockAddr, char *Sectorkey, char *serNum )
{
 char _status;
 unsigned recvBits;
 char i;
 char buff[12];


 buff[0] = authMode;
 buff[1] = BlockAddr;

 for ( i = 2; i < 8; i++ ) {
 buff[i] = Sectorkey[i-2];
 }

 for ( i = 8; i < 12; i++ ) {
 buff[i] = serNum[i-8];
 }

 _status = MFRC522_ToCard(  0x0E , buff, 12, buff, &recvBits );

 if ( ( _status !=  0  ) || !( MFRC522_Rd(  0x08  ) & 0x08 ) ) {
 _status =  2 ;
 }

 return _status;
}

char MFRC522_Write( char blockAddr, char *writeData )
{
 char _status;
 unsigned recvBits;
 char i;
 char buff[18];
 buff[0] =  0xA0 ;
 buff[1] = blockAddr;

 MFRC522_CRC( buff, 2, &buff[2] );
 _status = MFRC522_ToCard(  0x0C , buff, 4, buff, &recvBits );
 if ( (_status !=  0 ) || (recvBits != 4) || ( (buff[0] & 0x0F) != 0x0A) ) {
 _status =  2 ;
 }
 if (_status ==  0 ) {
 for ( i = 0; i < 16; i++ ) {
 buff[i] = writeData[i];
 }

 MFRC522_CRC( buff, 16, &buff[16] );
 _status = MFRC522_ToCard(  0x0C , buff, 18, buff, &recvBits );
 if ( (_status !=  0 ) || (recvBits != 4) || ( (buff[0] & 0x0F) != 0x0A ) ) {
 _status =  2 ;
 }
 }
 return _status;
}

char MFRC522_Read( char blockAddr, char *recvData )
{
 char _status;
 unsigned unLen;
 recvData[0] =  0x30 ;
 recvData[1] = blockAddr;

 MFRC522_CRC( recvData, 2, &recvData[2] );

 _status = MFRC522_ToCard(  0x0C , recvData, 4, recvData, &unLen );
 if ( (_status !=  0 ) || (unLen != 0x90) ) {
 _status =  2 ;
 }
 return _status;
}

char MFRC522_AntiColl( char *serNum )
{
 char _status;
 char i;
 char serNumCheck = 0;
 unsigned unLen;
 MFRC522_Wr(  0x0D , 0x00 );
 serNum[0] =  0x93 ;
 serNum[1] = 0x20;
 MFRC522_Clear_Bit(  0x08 , 0x08 );
 _status = MFRC522_ToCard(  0x0C , serNum, 2, serNum, &unLen );
 if (_status ==  0 ) {
 for ( i=0; i < 4; i++ ) {
 serNumCheck ^= serNum[i];
 }

 if ( serNumCheck != serNum[4] ) {
 _status =  2 ;
 }
 }
 return _status;
}






char MFRC522_isCard( char *TagType )
{
 if (MFRC522_Request(  0x26 , TagType ) ==  0 )
 return 1;
 else
 return 0;

}

char MFRC522_ReadCardSerial( char *str )
{
 char _status;
 _status = MFRC522_AntiColl( str );
 str[5] = 0;
 if (_status ==  0 )
 return 1;
 else
 return 0;
}

unsigned char MFRC_getVersion(void)
{
 return (MFRC522_Rd(0x37));
}
